(function() {
  var __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  PuppetEnterpriseConsole.CloningController = (function(_super) {

    __extends(CloningController, _super);

    function CloningController() {
      this.activateFirstTab = __bind(this.activateFirstTab, this);

      this.cancelCloning = __bind(this.cancelCloning, this);

      this.navigateAway = __bind(this.navigateAway, this);

      this.updatePreview = __bind(this.updatePreview, this);
      return CloningController.__super__.constructor.apply(this, arguments);
    }

    CloningController.prototype.routingKey = 'cloning';

    CloningController.set('skipLayout', true);

    CloningController.prototype.tabs = ['errors', 'failures', 'overwrites', 'creations', 'successes'];

    CloningController.prototype.updatePreview = function() {
      this.set('cloningState', 'preview');
      this.set('loadingState', 'loading');
      this.set('nodeCount', null);
      this.set('activeTab', null);
      return this.load();
    };

    CloningController.prototype.moveContentTop = function(height) {
      return $('#content-wrapper').css({
        top: $(this).outerHeight(true)
      });
    };

    CloningController.prototype.setupClone = function(node, type, title, variation) {
      var alreadyCloning, obj, target, targetNode, transfer, wasHidden,
        _this = this;
      this.unset('error');
      this.unset('cloningState');
      this.unset('loadingState');
      obj = {
        type: type,
        title: title
      };
      obj.parameters = variation.attributes;
      obj.nodes = variation.nodes;
      alreadyCloning = this.get('cloningResource');
      targetNode = $('#cloning-context');
      if (JSON.stringify(alreadyCloning) === JSON.stringify(obj)) {
        if (targetNode.is(':animated')) {
          return;
        }
        return targetNode.animate({
          top: -5
        }, {
          duration: 50
        }).animate({
          top: 0
        }, {
          duration: 400,
          easing: 'easeOutBounce'
        });
      } else {
        if (wasHidden = targetNode.is(":hidden")) {
          targetNode.css({
            display: 'block',
            overflow: 'hidden',
            height: 0
          });
        }
        transfer = $('<div class="ui-effects-transfer"></div>').appendTo(document.body).css({
          position: "absolute",
          padding: '0.5em',
          height: $(node).height(),
          width: $(node).width()
        });
        target = {
          top: [targetNode.offset().top, 'easeOutSine'],
          left: [targetNode.offset().left + (targetNode.width() - transfer.width()) / 2, 'easeOutSine'],
          opacity: 0,
          width: 0
        };
        if (targetNode.height()) {
          targetNode.parent().css({
            height: targetNode.height()
          });
        }
        transfer.css({
          zIndex: 1000000,
          backgroundColor: targetNode.css('backgroundColor'),
          top: $(node).offset().top,
          left: $(node).offset().left
        }).animate(target, {
          easing: 'easeInExpo',
          duration: 300,
          complete: function() {
            return targetNode.animate({
              height: 'show'
            }, {
              duration: 300,
              easing: 'easeOutBounce',
              step: wasHidden ? _this.moveContentTop : void 0,
              complete: function() {
                targetNode.parent().css({
                  height: ''
                });
                return transfer.remove();
              }
            });
          }
        });
        return targetNode.fadeOut(100, function() {
          targetNode.css({
            display: 'none',
            overflow: '',
            height: ''
          });
          return PuppetEnterpriseConsole.set('controllers.cloning.cloningResource', obj);
        });
      }
    };

    CloningController.prototype.preview = function() {
      if (!this.get('cloningResource')) {
        return this.redirect('/');
      }
      PuppetEnterpriseConsole.observe('currentRoute', this.navigateAway);
      return PuppetEnterpriseConsole.Node.observeAndFire('nodeSetID', this.updatePreview);
    };

    CloningController.prototype.navigateAway = function(currentRoute) {
      if ((currentRoute != null ? currentRoute.controller : void 0) !== "cloning") {
        PuppetEnterpriseConsole.Node.forget('nodeSetID', this.updatePreview);
        this.unset('cloningState');
        this.unset('loadingState');
        PuppetEnterpriseConsole.forget('currentRoute', this.navigateAway);
        return PuppetEnterpriseConsole.forget('currentRoute', this.cancelCloning);
      }
    };

    CloningController.prototype.clone = function() {
      PuppetEnterpriseConsole.Node.forget('nodeSetID', this.updatePreview);
      PuppetEnterpriseConsole.forget('currentRoute', this.navigateAway);
      PuppetEnterpriseConsole.observe('currentRoute', this.cancelCloning);
      this.set('cloningState', 'cloning');
      this.set('loadingState', 'loading');
      this.set('nodeCount', PuppetEnterpriseConsole.Node.get('selected').length);
      PuppetEnterpriseConsole.Resource[this.get('cloningResource').type].invalidate();
      return this.load();
    };

    CloningController.prototype.cancelCloning = function() {
      var _this = this;
      return $('#cloning-context').animate({
        marginTop: 'hide',
        height: 'hide'
      }, {
        duration: 200,
        easing: 'easeOutBack',
        step: this.moveContentTop,
        complete: function() {
          if (PuppetEnterpriseConsole.get('currentRoute.controller') === 'cloning') {
            history.go(-1);
          }
          _this.navigateAway();
          $('#content-wrapper').css({
            top: ''
          });
          return _this.unset('cloningResource');
        }
      });
    };

    CloningController.prototype.activateFirstTab = function() {
      var key, result, _i, _len, _ref, _results;
      result = this.get('result');
      _ref = this.tabs;
      _results = [];
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        key = _ref[_i];
        if (result['counts'][key]) {
          this.activateTab(null, key);
          break;
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    };

    CloningController.prototype.activateTab = function(_, subject) {
      var result;
      result = this.get('result');
      this.set('activeTab', subject);
      return this.render({
        source: "cloning/preview/" + subject,
        into: "panel",
        context: Batman.RenderContext.root().descend(this).descend(result)
      });
    };

    CloningController.prototype.load = function() {
      var res,
        _this = this;
      this.openConnections || (this.openConnections = 0);
      this.openConnections++;
      res = this.get('cloningResource');
      this.unset('error');
      return $.ajax({
        url: this.get('cloningState') === 'preview' ? '/live-management/lm/clone/preview' : '/live-management/lm/clone',
        type: 'POST',
        data: {
          type: res.type,
          title: res.title,
          parameters: res.parameters,
          origin_nodes: res.nodes,
          nodeset_id: PuppetEnterpriseConsole.Node.get('nodeSetID')
        },
        success: function(data) {
          var x;
          data.sourceData = res;
          data.isEmpty = !((function() {
            var _i, _len, _ref, _ref1, _results;
            _ref = this.tabs;
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              x = _ref[_i];
              _results.push((_ref1 = data.counts[x]) != null ? _ref1 : 0);
            }
            return _results;
          }).call(_this)).reduce(function(a, i) {
            return a + i;
          });
          _this.set('result', data);
          return _this.activateFirstTab();
        },
        error: function(obj) {
          return _this.set('error', ("<h3>" + (Batman.helpers.capitalize(_this.get('cloningState'))) + " failed</h3>") + (obj.responseText != null ? "<div class=\"well\">" + obj.responseText + "</div>" : ''));
        },
        complete: function() {
          return --_this.openConnections || _this.set('loadingState', 'loaded');
        }
      });
    };

    return CloningController;

  })(Batman.Controller);

}).call(this);
